/*
Fondamenti di Informatica e Laboratorio
Ingegneria Telematica
Appello del 18/06/2007

Tempo a disposizione: 2h  30m


Scrivere un programma per la gestione delle informazioni relative alle operazioni relative ad una banca.
La banca ha 4 sportelli, uno per ogni tipo di operazione. Ogni sportello ha una propria coda di clienti.
I clienti sono caratterizzati dalle seguenti informazioni: nome, codice fiscale, tipo di operazione.
Nel momento in cui un cliente viene servito, vengono conservate in una tabella allocata dinamicamente le seguenti informazioni relative alloperazione appena eseguita: codice fiscale, importo delloperazione, data delloperazione.
La tabella contiene 4 righe, una per tipo di operazione.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.Inserimento in coda di un nuovo cliente;
2.Visualizzazione dei clienti di una certa coda;
3.Servizio del primo elemento della coda e inserimento delloperazione appena eseguita nella tabella;
4.Visualizzazione delle operazioni gi eseguite relative a una certa data;
5.Salvataggio su file delle operazioni gi eseguite

Si assuma che all'avvio del programma vengano caricate da file e inserite in tabella tutte le operazioni salvate in precedenti esecuzioni del programma.

*/



#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
	char codfiscale[17],data[11];
	float importo;
	int tipo;
 } operazione;


 typedef struct {
	char nome[30],codfiscale[17];
	int tipo;
	} cliente;

struct atomo {
	cliente dato;
struct atomo *next;
};

typedef struct {
  struct atomo *primo,*ultimo;
   } coda;


void leggi_cliente(cliente *ps);
void in_coda(coda *Q, cliente s);
void vis_coda(coda Q);
cliente  out_coda(coda *Q);
void leggi_operazione(operazione *ps, cliente s);
void ins_tabella(operazione *TS[5], int *N, operazione s);
void visualizza(operazione *TS[5], int *N);
void salva(operazione *TS[5], int *N);
void inizializza(operazione *TS[5], int *N);
void libera_coda(coda *Q);
void menu();


main() {
 operazione *TS[4],op;
 coda Q[4];
 cliente cl;
 int N[5],scelta,tipo;


 for(tipo=0;tipo<4;tipo++)
	{	TS[tipo]=NULL;
 		N[tipo]=0;
 		Q[tipo].primo=NULL;
        Q[tipo].ultimo=NULL;

	}

 inizializza(TS,N);

 do { menu();
	scanf("%d",&scelta);
	switch(scelta) {
		case 1: leggi_cliente(&cl);
				in_coda(&Q[cl.tipo],cl);
				break;
		case 2: printf("Tipo di coda: ");
		        scanf("%d",&tipo);
                vis_coda(Q[tipo]);
                break;
		case 3:	printf("Tipo di coda: ");
		        scanf("%d",&tipo);
                if(Q[tipo].primo==NULL)
                     {printf("Coda vuota\n");
                      break;
                      }
                cl=out_coda(&Q[tipo]);
				leggi_operazione(&op,cl);
				ins_tabella(TS,N,op);
		        break;
        case 4:	visualizza(TS,N);
				break;
		case 5: salva(TS,N);
                break;
		default:;
	}
  } while (scelta!=0);

  for(tipo=0;tipo<4;tipo++)
  	  { free(TS[tipo]);
        libera_coda(&Q[tipo]);
      }

}

void leggi_cliente(cliente *ps){
	printf("Nome: ");
	scanf("%s",ps->nome);
	printf("Codice fiscale:");
    scanf("%s",ps->codfiscale);
	printf("Tipo (0,1,2,3):");
    scanf("%d",&ps->tipo);

}

void in_coda(coda *Q, cliente s)
{
 struct atomo *aux;

 aux=malloc(sizeof(struct atomo));
 if(aux==NULL) return;
 aux->dato=s;
 if(Q->primo==NULL)
  Q->primo=aux;
 else Q->ultimo->next=aux;
 Q->ultimo=aux;

}

void vis_coda(coda Q)
{
    struct atomo *a;

    a=Q.primo;
    while(a!=NULL)
    {printf("Nome: %s \n",a->dato.nome);
	 printf("Codice fiscale: %s\n",a->dato.codfiscale);
	 a=a->next;
	}
}
cliente  out_coda(coda *Q)
{
  cliente c;
  struct atomo *aux;

  aux=Q->primo;
  Q->primo=aux->next;
  c=aux->dato;

  free(aux);
  if(Q->primo==NULL)
   Q->ultimo=NULL;

 return c;
}

void leggi_operazione(operazione *ps, cliente s)
{
 int i;

    strcpy(ps->codfiscale,s.codfiscale);
	ps->tipo=s.tipo;
	printf("Data :");
    scanf("%s",ps->data);
    printf("Importo: ");
    scanf("%f",&ps->importo);
}


void ins_tabella(operazione *TS[4], int *N, operazione s)
{
 operazione *aux;
 int c;

 c=s.tipo;
 aux=realloc(TS[c],sizeof(operazione)*(N[c]+1));
 if(aux==NULL)
	{ 	printf("Mem. non allocata\n");
		return;
	}
 TS[c]=aux;
 TS[c][N[c]]=s;
 N[c]++;
}


void visualizza(operazione *TS[4], int *N)
{
	int i,j;
	char data[11];

	 printf("Data delle operazioni da visualizzare: ");
	 scanf("%s",data);

	 for(i=0;i<4;i++)
		 for(j=0;j<N[i];j++)
			 if(strcmp(TS[i][j].data,data)==0)
				 { printf("Cod. fiscale: %s\n",TS[i][j].codfiscale);
			       printf("Importo: %f\n",TS[i][j].importo);
				}
}


void salva(operazione *TS[4], int *N)
{
	FILE *pf;
	int i;
	pf=fopen("operazioni.dat","wb");
	if(pf!=NULL)
		{ for(i=0;i<4;i++)
	         fwrite(TS[i],sizeof(operazione),N[i],pf);
		  fclose(pf);
	}
	else printf("Errore in scrittura\n");
}

void inizializza(operazione *TS[5], int *N)
{
	operazione op;
    FILE *pf;

	printf("Inizializzazione\n");
	pf=fopen("operazioni.dat","rb");
	if(pf!=NULL)
		{ while(fread(&op,sizeof(operazione),1,pf))
	        ins_tabella(TS,N,op);
		  fclose(pf);
	    }
	else printf("Nessuna operazione precedentemente salvata\n");
}


void menu(){
 printf("Scegli tra le seguenti opzioni\n");
 printf("1) Ins di un nuovo cliente\n");
 printf("2) Vis. clienti\n");
 printf("3) Servizio coda \n");
 printf("4) Visualizza operazioni eseguite per data\n");
 printf("5) Salva su file\n");
 printf("0) Fine programma\n\n");
}



void libera_coda(coda *Q)
{
 struct atomo *aux;

  while(Q->primo!=NULL)
   {aux=Q->primo;
    Q->primo=aux->next;
    free(aux);
   }
  Q->ultimo=NULL;
}












